

 package helloworld;

import java.lang.*;
import java.io.*;
import javax.microedition.lcdui.*;
import javax.microedition.io.*;
import javax.bluetooth.*;

public class HelloServer extends BlueTMIDlet {

    /**
     * Creates a server object. Accepts a single
     * connection from a client and prints the data
     * sent from the client to the screen.
     */
    public void run() {

        // Create a Form and add the Exit command to the Form
        Form f = new Form("Server");
        f.addCommand(new Command("Exit", Command.EXIT, 1));
        f.setCommandListener(this);
        Display.getDisplay(this).setCurrent(f);

        try {
            // Make the local device discoverable for the
            // client to locate
            LocalDevice local = LocalDevice.getLocalDevice();
            if (!local.setDiscoverable(DiscoveryAgent.GIAC)) {
                f.append("Failed to change to the " +
                    "discoverable mode");
                return;
            }

            // Create a server connection object to accept
            // a connection from a client
            StreamConnectionNotifier notifier =
                (StreamConnectionNotifier)
                Connector.open("btspp://localhost:" +
                    "86b4d249fb8844d6a756ec265dd1f6a3");

            // Accept a connection from the client
            StreamConnection conn = notifier.acceptAndOpen();
            // Open the input to read data from
            InputStream in = conn.openInputStream();
            ByteArrayOutputStream out = new
                ByteArrayOutputStream();

            // Read the data sent from the client until
            // the end of stream
            int data;
            while ((data = in.read()) != -1) {
                out.write(data);
            }

            // Add the text sent from the client to the Form
            f.append(out.toString());

            // Close all open resources
            in.close();
            conn.close();
            notifier.close();
        } catch (BluetoothStateException e) {
            f.append("BluetoothStateException: ");
            f.append(e.getMessage());
        } catch (IOException e) {
            f.append("IOException: ");
            f.append(e.getMessage());
        }
    }
}