
package helloworld;

import java.lang.*;
import java.io.*;
import javax.microedition.io.*;
import javax.microedition.lcdui.*;
import javax.bluetooth.*;

public class HelloClient extends BlueTMIDlet {

    /**
     * Connects to the server and sends 'Hello, World'
     * to the server.
     */
    public void run() {

        // Creates the Form and adds the Exit Command to it
        Form f = new Form("Client");
        f.addCommand(new Command("Exit", Command.EXIT, 1));
        f.setCommandListener(this);
        Display.getDisplay(this).setCurrent(f);

        try {
            // Retrieve the connection string to connect to
            // the server
            LocalDevice local =
                LocalDevice.getLocalDevice();
            DiscoveryAgent agent = local.getDiscoveryAgent();

            String connString = agent.selectService(
                new UUID("86b4d249fb8844d6a756ec265dd1f6a3", false),
                ServiceRecord.NOAUTHENTICATE_NOENCRYPT, false);

            if (connString != null) {
                try {
                    // Connect to the server and send 'Hello, World'
                    StreamConnection conn = (StreamConnection)
                        Connector.open(connString);

                    OutputStream out = conn.openOutputStream();
                    out.write("Hello, World".getBytes());
                    out.close();
                    conn.close();

                    f.append("Message sent correctly");
                } catch (IOException e) {
                    f.append("IOException: ");
                    f.append(e.getMessage());
                }
            } else {
                // Unable to locate a service so just print an error
                // message on the screen
                f.append("Unable to locate service");
            }
        } catch (BluetoothStateException e) {
            f.append("BluetoothStateException: ");
            f.append(e.getMessage());
        }
    }
}